#!/usr/bin/env python
# -*- coding: UTF-8 -*-

def mig_multi_val(*args):
    """ concatene variables
    """
    res = []
    for arg in args:
        if arg == 'aucun' or arg == '' or arg is '' or arg == None or len(arg) == 0 or arg =='non':
            continue
        # gestion des valeurs multi
        try:
            if arg.startswith("["):
                ev_args = eval(arg)
                assert type(ev_args) == list
                for ev_arg in ev_args:
                    if ev_arg != "": # and ev_arg not in res:
                        res.append(ev_arg)
            else:
                if arg != '':
                    res.append(arg)
        except:
            if arg != '':
                res.append(arg)
    return(res)

def test_slaves(master, slave):
    """
    valide que chaque master ai une slave
    """
    if master.startswith('['):
       master = eval(master)
       assert type(master) == list
    if slave.startswith('['):
        slave = eval(slave)
        assert type(slave) == list

    print master, slave
    nmaster = len(master)
    nslave = len(slave)
    for num in range(0, nmaster):
        #print num, master[num]
        try:
            if slave[num]:
                #print 'pass', slave[num]
                pass
        except:
            #print 'del', master[num]
            del master[num]
    #print master,slave
    return master


def eth0_pub(ip):
    if ip != None:
        if ip.startswith('10.'):
            return 'non'
        else:
            return 'oui'



def addressInNetwork(ip, net):
   import socket,struct
   ipaddr = int(''.join([ '%02x' % int(x) for x in ip.split('.') ]), 16)
   netstr, bits = net.split('/')
   netaddr = int(''.join([ '%02x' % int(x) for x in netstr.split('.') ]), 16)
   mask = (0xffffffff << (32 - int(bits))) & 0xffffffff
   return (ipaddr & mask) == (netaddr & mask)


def get_interface(data,ips, masks, interfaces, route_adresse, route_netmask, route_int):
    #from creole.error import TypeEoleError
    from creole3 import eosfunc

    interface_found = False
    if data is '' or data == '':
        return
    for num in range(0, len(ips)):
        if ips[num] is '' or masks[num] is '' :
             continue
        try:
            if addressInNetwork(data, eosfunc.calc_network(str(ips[num]),str(masks[num])) + '\\' + eosfunc.calc_classe(str(masks[num]))):
                interface_found = True
                return interfaces[num]
        except:
            continue

    for num in range(0, len(route_adresse)):
        if route_adresse[num] is '' or route_netmask[num] is '' :
             continue
        try:
            if addressInNetwork(data, eosfunc.calc_network(str(route_adresse[num]),str(route_netmask[num])) + '\\' + eosfunc.calc_classe(str(route_netmask[num]))):
                interface_found = True
                return route_int[num]
        except:
            continue

    if interface_found == False:
        return eth0



def valid_dmz(data,ip,mask):
    from creole3 import eosfunc
    from creole3.error import TypeEoleError
    if data and ip and mask:
        if eosfunc.calc_network_auto(ip, mask) == eosfunc.calc_network_auto(data, mask):
            return True
        else:
            raise TypeEoleError("Les ip %s et %s ne sont pas dans le même réseau" % (ip, data))


def valid_networks(data,**conditions):
    from creole3 import eosfunc
    from creole3.error import TypeEoleError
    ips = []
    #masks[]
    network_found = False
    if data is '' or data == '':
        return
    for num in range(0, len(conditions), 2):
        if not conditions.has_key('condition_%s'%(num+1)) or not conditions.has_key('condition_%s'%(num+2)):
            raise ValueError('Condition %s valid_networks inconnue'%num+1)
        ip = conditions.get('condition_%s'%(num+1))
        mask = conditions.get('condition_%s'%(num+2))
        if ip is '' or mask is '' :
             continue
        ips.append(ip)
        #masks.append(mask)
        try:
            if eosfunc.calc_network_auto(ip, mask) == eosfunc.calc_network_auto(data, mask):
                network_found = True
                return True
        except:
            continue
    if network_found == False:
        raise TypeEoleError("L'ip %s ne correspond à aucun des réseaux parmi %s" % (data, ips))
        return False



def convert_alias(if_alias,ip_eth0,alias_eth0,alias_actif_eth0):
    #if if_alias.startswith("["):
    #    print "multi"
    try:
        if alias_actif_eth0 == 'non':
            return ip_eth0
        if if_alias is '' or if_alias == '':
            return ''
        if if_alias == 'eth0':
            return ip_eth0
        aliaseth0 = eval(alias_eth0)
        if if_alias == 'eth0:0':
            return aliaseth0[0]
        if if_alias == 'eth0:1':
            return aliaseth0[1]
        if if_alias == 'eth0:2':
            return aliaseth0[2]
        if if_alias == 'eth0:3':
            return aliaseth0[3]
    except:
        return ''

def get_peda_net(nets):
    try:
        for network in nets:
            if network.startswith('172'):
                return network
    except:
        return ''

def gen_tunnels(id,oui):
    if oui == "Oui":
        if id:
            file = open("/tmp/gen_tunnels.txt", "a")
            file.write(id + "\n")
            file.close()
    return "non"

